﻿package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.Point;
	
	public class Suiveur extends Sprite
	{
		private var mover:Sprite;
		private var i:Number = 0;
		public function Suiveur()
		{
			addEventListener(Event.ADDED_TO_STAGE, addedHandler);
		}
		private function addedHandler(e:Event):void
		{
			mover = new Sprite();
			addChild(mover);
			addEventListener(Event.ENTER_FRAME, enterHandler);
		}
		private function enterHandler(e:Event):void
		{
			mover.x+= -(mouseX-stage.stageWidth/2.4)/10;
			mover.y+= -(mouseY-stage.stageHeight)/10;
			drawElem(i++);
		}
		private function drawElem(nbr:Number):void
		{
			var elem:Sprite = new Sprite();
			elem.name = "ch"+i;
			
			elem.graphics.beginFill(Math.random()*0x00ccff,100);
			elem.graphics.drawRect(mouseX-mover.x,mouseY-mover.y,Math.cos(i*Math.PI/150)*7,Math.cos(i*Math.PI/100)*10);
			elem.graphics.drawRect(mouseX-mover.x,mouseY-mover.y,Math.cos(i*Math.PI/10)*400,Math.cos(i*Math.PI/100)*10);
			elem.graphics.drawRect(mouseX-mover.x/2,mouseY-mover.y-4,Math.cos(i*Math.PI/10)*400,Math.cos(i*Math.PI/100)*10);
			elem.graphics.beginFill(0x00ffff,100);
			elem.graphics.drawRect(mouseX-mover.x*2,mouseY-mover.y/4,Math.cos(i*Math.PI/10)*40,Math.cos(i*Math.PI/100)*10);


			
			elem.graphics.endFill();
			elem.addEventListener(Event.ENTER_FRAME,fadeOut);
			mover.addChild(elem);
		}
		private function fadeOut(e:Event):void{
			e.currentTarget.x += Math.random()*10;
			e.currentTarget.y += Math.random()*20;
			e.currentTarget.alpha-=0.010;
			if(e.currentTarget.alpha<=0){
				if(mover.getChildByName(e.currentTarget.name)!=null){
					e.currentTarget.removeEventListener(Event.ENTER_FRAME,fadeOut);
					mover.removeChild(mover.getChildByName(e.currentTarget.name));
				}
			}
		}
	}
}